

#include "BUILTIN.h"
extern OBJ _AISeq_26(OBJ);extern OBJ __AISeq_26;
extern OBJ _AISeq_27(OBJ);extern OBJ __AISeq_27;

#include "Nat.h"
extern OBJ _AISeqMapEnv_4(OBJ,OBJ,OBJ);OBJ __AISeqMapEnv_4; /* * */
extern OBJ _AISeqMapEnv_5(OBJ,OBJ);OBJ __AISeqMapEnv_5; /* *'5 */
extern OBJ _AISeqMapEnv_6(OBJ,OBJ,OBJ,OBJ);OBJ __AISeqMapEnv_6; /* *'6 */

extern OBJ _AISeqMapEnv_4(OBJ x1,OBJ x2,OBJ x3) /* * */
{OBJ r;
 CPCLS(__AISeqMapEnv_5,1);
 CPCLS(__AISeqMapEnv_6,1);
 CPCLS(__AISeq_27,1);
 CPCLS(x1,1);
 CPPRD(x3,1);
 {OBJ x4;OBJ x6;OBJ x7;OBJ x8;OBJ x9;
  x4=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AISeq_27,2))(__AISeq_27,x3,__ABUILTIN_20);
  {OBJ t=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x1,2))(x1,x2,x4);
   x6=FLD1(t,1);
   x7=FLD1(t,2);
   DSPRDF(t);}
  x8=(*(OBJ(*)(OBJ,OBJ))METHOD(__AISeqMapEnv_5,1))(__AISeqMapEnv_5,x7);
  x9=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))METHOD(__AISeqMapEnv_6,3))(__AISeqMapEnv_6,x1,x3,x6);
  PRD1(2,r);FLD1(r,1)=x8;FLD1(r,2)=x9;}
 return r;}

extern OBJ _AISeqMapEnv_5(OBJ x1,OBJ x2) /* *'5 */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AISeqMapEnv_6(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* *'6 */
{OBJ r;
 CPCLS(__AISeq_26,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AISeq_26,2))(__AISeq_26,x2,__ABUILTIN_20);
  r=_AISeqMapEnv_4(x1,x3,x5);}
 return r;}

static OBJ _mt_4_0_3(OBJ t,OBJ t1,OBJ t2,OBJ t3) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,3);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 FLDCLS(r,3)=t3;
 return r;}

static OBJ _mt_4_0_4(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4) 
{OBJ r;
 DCCLS(t,1);
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))ENTRY(t))(t1,t2,t3,t4);
 return r;}

static OBJ _mt_4_3_1(OBJ t,OBJ t1) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  COPY(FLDCLS(t,3),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),t1);
 return r;}
static OBJ _mt_4_3_1_l(OBJ t,OBJ t1) 
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),t1);
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  DCCLS(t,1);
  FLDCLS(t,1)=NIL;FLDCLS(t,2)=NIL;FLDCLS(t,3)=NIL;
  COPY(r,1);LZYCLS(t,r);}
 return r;}

init_AISeqMapEnv()
{
 static int visited=0; if(visited) return; visited=1;
 init_AISeq();
 init_ANat();
 init_AOption();
 init_ASeq();
 LCLS(4,_AISeqMapEnv_6,__AISeqMapEnv_6);
 LCLS(2,_AISeqMapEnv_5,__AISeqMapEnv_5);
 CLS(3,_AISeqMapEnv_4,__AISeqMapEnv_4);
 MTH(4,0,3,_mt_4_0_3);LZYMTH(4,0,3,_mt_4_0_3);
 MTH(4,0,4,_mt_4_0_4);LZYMTH(4,0,4,_mt_4_0_4);
 MTH(4,3,1,_mt_4_3_1);LZYMTH(4,3,1,_mt_4_3_1_l);}

